
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Wallet_transactionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const wallet_transactions = await db.wallet_transactions.create(
            {
                id: data.id || undefined,
        
        currency: data.currency
        ||
        null
            ,
            
        direction: data.direction
        ||
        null
            ,
            
        amount: data.amount
        ||
        null
            ,
            
        balance_after: data.balance_after
        ||
        null
            ,
            
        reason: data.reason
        ||
        null
            ,
            
        reference: data.reference
        ||
        null
            ,
            
        occurred_at: data.occurred_at
        ||
        null
            ,
            
        note: data.note
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await wallet_transactions.setUser( data.user || null, {
            transaction,
        });
        

        

        

        return wallet_transactions;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const wallet_transactionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                currency: item.currency
            ||
            null
            ,
            
                direction: item.direction
            ||
            null
            ,
            
                amount: item.amount
            ||
            null
            ,
            
                balance_after: item.balance_after
            ||
            null
            ,
            
                reason: item.reason
            ||
            null
            ,
            
                reference: item.reference
            ||
            null
            ,
            
                occurred_at: item.occurred_at
            ||
            null
            ,
            
                note: item.note
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const wallet_transactions = await db.wallet_transactions.bulkCreate(wallet_transactionsData, { transaction });

        // For each item created, replace relation files
        

        return wallet_transactions;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const wallet_transactions = await db.wallet_transactions.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.currency !== undefined) updatePayload.currency = data.currency;
        
        
        if (data.direction !== undefined) updatePayload.direction = data.direction;
        
        
        if (data.amount !== undefined) updatePayload.amount = data.amount;
        
        
        if (data.balance_after !== undefined) updatePayload.balance_after = data.balance_after;
        
        
        if (data.reason !== undefined) updatePayload.reason = data.reason;
        
        
        if (data.reference !== undefined) updatePayload.reference = data.reference;
        
        
        if (data.occurred_at !== undefined) updatePayload.occurred_at = data.occurred_at;
        
        
        if (data.note !== undefined) updatePayload.note = data.note;
        
        
        updatePayload.updatedById = currentUser.id;

        await wallet_transactions.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await wallet_transactions.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        

        
        

        

        return wallet_transactions;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const wallet_transactions = await db.wallet_transactions.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of wallet_transactions) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of wallet_transactions) {
                await record.destroy({transaction});
            }
        });


        return wallet_transactions;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const wallet_transactions = await db.wallet_transactions.findByPk(id, options);

        await wallet_transactions.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await wallet_transactions.destroy({
            transaction
        });

        return wallet_transactions;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const wallet_transactions = await db.wallet_transactions.findOne(
            { where },
            { transaction },
        );

        if (!wallet_transactions) {
            return wallet_transactions;
        }

        const output = wallet_transactions.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await wallet_transactions.getUser({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.reference) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'wallet_transactions',
                        'reference',
                        filter.reference,
                    ),
                };
            }
            
            if (filter.note) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'wallet_transactions',
                        'note',
                        filter.note,
                    ),
                };
            }
            

            
            

            
            if (filter.amountRange) {
                const [start, end] = filter.amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    amount: {
                    ...where.amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    amount: {
                    ...where.amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.balance_afterRange) {
                const [start, end] = filter.balance_afterRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    balance_after: {
                    ...where.balance_after,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    balance_after: {
                    ...where.balance_after,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.occurred_atRange) {
                const [start, end] = filter.occurred_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    occurred_at: {
                    ...where.occurred_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    occurred_at: {
                    ...where.occurred_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.currency) {
                where = {
                    ...where,
                currency: filter.currency,
            };
            }
            
            if (filter.direction) {
                where = {
                    ...where,
                direction: filter.direction,
            };
            }
            
            if (filter.reason) {
                where = {
                    ...where,
                reason: filter.reason,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.wallet_transactions.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'wallet_transactions',
                        'reference',
                        query,
                    ),
                ],
            };
        }

        const records = await db.wallet_transactions.findAll({
            attributes: [ 'id', 'reference' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['reference', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.reference,
        }));
    }

    
};

